;***************************************************************
;		PRO_RELAY_AUTOVOLTAGE_1
;***************************************************************
		DATA0	EQU	21H	
		DATA1	EQU	0AFH
		DATA2	EQU	32H
		DATA3	EQU	26H
		DATA4	EQU	0ACH
		DATA5	EQU	64H
		DATA6	EQU	60H
		DATA7	EQU	2FH
		DATA8	EQU	20H
		DATA9	EQU	24H
		DATAP	EQU	38H	
		DATAE	EQU	70H	
		DATA_	EQU	0F7H	
		DATAr	EQU	0FAH
		DATAt	EQU	0F0H
		DATAc	EQU	0F2H
		DATAl	EQU	0F9H
		DATAn	EQU	0EAH
		DATAo	EQU	0E2H
		PASS	EQU	55H
		REGIB	EQU	0F0H
		BUZZER	BIT	P2.3
		RELAY	BIT	P3.5
		CONTACT	BIT	P3.7
		COILRE	BIT	P3.6
		PINOHM	BIT	P3.3
		DIGI1	BIT	P2.7
		DIGI2	BIT	P2.6
		DIGI3	BIT	P2.5
		SW1	EQU	P2.0	;SWITCH RUN
		SW2	EQU	P2.1	;SWITCH UP
		SW3	EQU	P2.2	;SWITCH DOWN
			ORG	58H
		DP1:		DS	1
		DP2:		DS	1
		DP3:		DS	1
		DIGI_0:		DS	1
		DIGI_1:		DS	1
		DIGI_2:		DS	1
		BITPRO:		DS	1
		D_OHM:		DS	1
		RAMVOLT:	DS	1
		RAMVOLT2:	DS	1
		RAMEX:		DS	1
		RAMOHM:	DS	1
		RAMOHM2:	DS	1
		RAMTIMER:	DS	1
		RAMTIMER2:	DS	1
		RAMDIS:		DS	1
		RAMALA:		DS	1
		DATA_OHM:	DS	1
		RAM_DEC:	DS	1
			ORG	0000H
		JMP	START
			ORG	0030H
START:		MOV	RAMOHM2,#0FFH
		MOV	RAMTIMER,#0FFH
		MOV	DP3,#DATA_
		MOV	DP2,#DATA_
		MOV	DP1,#DATA_
		JMP	LOOPST
LOPEN:		mov	dp1,#dataE
		mov	dp2,#dataP
		mov	dp3,#data0
LOOPST:		MOV	SP,#10H
		MOV	P0,#0FFH
		MOV	P2,#11100111B
		MOV	P1,#00H
		MOV	P3,#11001000B
		JNB	SW1,PROGRAM1
		JNB	SW2,PROGRAM2
		JNB	SW3,PROGRAM3		
		call	display
		JMP	LOOPST
PROGRAM1:	CALL	ALARM
		MOV	RAMTIMER2,#0FFH
		MOV	RAMOHM2,#0FFH
		CALL	COIL
		CALL	VOLT
		CALL	EX00
		CALL	DELAY2
		CALL	DELAY2
		CALL	DELAY2
		CALL	DELAY2
		CALL	OHM
		CALL	DELAY2
		CALL	TIMER
		MOV	RAMVOLT,RAMVOLT2
		CALL	PROVOLT
		JNB	SW1,$
		JMP	LOOPST
;
PROGRAM2:	CALL	ALARM
		MOV	RAMTIMER,RAMTIMER2
		CALL	PROTIMER
		JNB	SW2,$
		JMP	LOOPST
;
PROGRAM3:	CALL	ALARM
		MOV	RAMOHM,RAMOHM2
		CALL	PROOHM
		JNB	SW3,$
		JMP	LOOPST
;***********************************************************
;		 TEST	EX
;***********************************************************
EX00:		MOV	P3,RAMEX
		MOV	R3,#18H
EX11:		CLR	RELAY
		CALL	DELAY1
		CALL	DELAY1
		SETB	RELAY
		CALL	DELAY1
		CALL	DELAY1
		DJNZ	R3,EX11
		MOV	R3,#05H
EX22:		CLR	RELAY
		CALL	DELAY2
		CALL	DELAY2
		SETB	RELAY
		CALL	DELAY2
		CALL	DELAY2
		DJNZ	R3,EX22
		RET
;***********************************************************
;		 TEST	COIL
;***********************************************************
COIL:		SETB	P3.0
		SETB	P3.1
		SETB	P3.2
		JNB	COILRE,COIL1
		RET
COIL1:		MOV	DP3,#DATAc
		MOV	DP2,#DATAo
		MOV	DP1,#DATAl
		CALL	ALARM
		CALL	ALARM
		CALL	ALARM
		CALL	ALARM
		JMP	LOOPST
;***********************************************************
;		 TEST	VOLT
;***********************************************************
VOLT:		ANL	P3,#11101000B
VOLT0:		CLR	RELAY
		INC	P3
		MOV	A,P3
		ANL	A,#00010111B
		CJNE	A,#00010111B,VOLT01
		MOV	DP3,#DATAc
		MOV	DP2,#DATAo
		MOV	DP1,#DATAn
		CALL	ALARM
		CALL	ALARM
		CALL	ALARM
		CALL	ALARM
		JMP	LOOPST
VOLT01:		CJNE	A,#07H,VOLT1
		SETB	P3.4
		CLR	P3.0
		CLR	P3.1
		CLR	P3.2
VOLT1:		SETB	RELAY
		CALL	DELAY2
		JB	CONTACT,VOLT0
		MOV	A,#00H
		JNB	P3.4,VOLT2
		ADD	A,#08H
VOLT2:		MOV	REGIB,P3
		ANL	REGIB,#07H
		ADD	A,B
		MOV	B,#05H
		MUL	AB
		CJNE	A,#10D,VOLT3
		ADD	A,#02D
VOLT3:		CJNE	A,#25D,VOLT4
		MOV	A,#24D
VOLT4:		MOV	RAMVOLT,A
		MOV	RAMVOLT2,A
		MOV	RAMEX,P3
		JMP	PROVOLT
;***********************************************************
;		TEST	OHM
;***********************************************************
OHM:		MOV	DATA_OHM,#00H
		MOV	A,RAMEX
		ORL	A,#10000000B
		MOV	P3,A
		SETB	RELAY
		CALL	DELAY2
		CALL	DELAY2
		MOV	P1,#0FFH
OHM0:		INC	P1
		MOV	A,P1
		MOV	A,P1
		MOV	A,P1
		MOV	A,P1
		CJNE	A,#216D,OHM1
		CLR	RELAY
		MOV	RAMOHM,#0FFH
		JMP	OHMOUT
OHM1:		JB	PINOHM,OHM0
		CLR	RELAY
		CJNE	A,#45D,OHM_2
		JMP	OHM4
OHM_2:		CJNE	A,#44D,OHM_3
		JMP	OHM4
OHM_3:		MOV	R7,#45D
OHM2:		DEC	A
		DJNZ	R7,OHM2
		MOV	B,#05H
		MUL	AB
		MOV	RAMOHM,A
		MOV	R7,#100D
OHM2_1:		DEC	A
		CJNE	A,#00H,OHM3
		JMP	OHMOUT
OHM3:		DJNZ	R7,OHM2_1
		MOV	RAMOHM,#0FFH
		JMP	OHMOUT
OHM4:		MOV	RAMOHM,#02H
OHMOUT:	MOV	RAMOHM2,RAMOHM
		RET
;***********************************************************
;		TEST	TIMER
;***********************************************************
TIMER:		MOV	A,RAMEX
		ORL	A,#10000000B
		MOV	P3,A
		SETB	CONTACT
		SETB	RELAY
		MOV	RAMTIMER,#00H
		MOV	TMOD,#01H
LOTIMER:	MOV	TH0,#0FCH
		MOV	TL0,#17H
		SETB	TR0
		JNB	TF0,$
		CLR	TR0
		CLR	TF0
		INC	RAMTIMER
		JNB	CONTACT,TIMEROUT
		MOV	A,RAMTIMER
		CJNE	A,#62H,LOTIMER
		MOV	RAMTIMER2,#0FFH
TIMEROUT:	MOV	RAMTIMER2,A
		CLR	RELAY
		RET
;***********************************************************
;		 DISPLAY
;***********************************************************
DISPLAY:		MOV	P0,DP3
		MOV	P2,#11010111B
		CALL	DELAY
		MOV	P0,DP2
		MOV	P2,#10110111B
		CALL	DELAY
		MOV	P0,DP1
		MOV	P2,#01110111B
		CALL	DELAY
		MOV	P2,#11100111B
		RET
;
;***********************************************************
;		PROSESER  TIMER
;***********************************************************
PROTIMER:	MOV	A,RAMTIMER
		CJNE	A,#0FFH,PROTIMER0
		MOV	DP3,#DATAE
		MOV	DP2,#DATAr
		MOV	DP1,#DATAr
		RET
PROTIMER0:	MOV	DIGI_0,#00H
		MOV	DIGI_1,#00H
		MOV	DIGI_2,#00H
		MOV	A,#0AH
PROTIMER1:	INC	DIGI_2
		CJNE	A,DIGI_2,PROTIMER2
		MOV	DIGI_2,#0FFH
		INC	DIGI_1
		CJNE	A,DIGI_1,PROTIMER1
		MOV	DIGI_1,#00H
		INC	DIGI_0
		CJNE	A,DIGI_0,PROTIMER1
		JMP	CHANGTIMER
PROTIMER2:	DJNZ	RAMTIMER,PROTIMER1
;
CHANGTIMER:	MOV	R0,#DP1
		MOV	A,DIGI_2
		CALL	COMPY
		MOV	R0,#DP2
		MOV	A,DIGI_1
		CALL	COMPY
		MOV	DP3,#DATAt
		RET	
;***********************************************************
;		PROSESER  VOLT
;***********************************************************
PROVOLT:	MOV	DIGI_0,#00H
		MOV	DIGI_1,#00H
		MOV	DIGI_2,#00H
		MOV	A,#0AH
PROVOLT1:	INC	DIGI_2
		CJNE	A,DIGI_2,PROVOLT2
		MOV	DIGI_2,#0FFH
		INC	DIGI_1
		CJNE	A,DIGI_1,PROVOLT1
		MOV	DIGI_1,#00H
		INC	DIGI_0
		CJNE	A,DIGI_0,PROVOLT1
		JMP	CHANGVOLT
PROVOLT2:	DJNZ	RAMVOLT,PROVOLT1
;
CHANGVOLT:	MOV	R0,#DP1
		MOV	A,DIGI_2
		CALL	COMPY
		MOV	R0,#DP2
		MOV	A,DIGI_1
		CALL	COMPY
		MOV	DP3,#DATAE
		RET	
;***********************************************************
;		PROSESER  OHM
;***********************************************************
PROOHM:	MOV	A,RAMOHM
		CJNE	A,#0FFH,PROOHM0
		MOV	DP3,#DATA0
		MOV	DP2,#DATAP
		MOV	DP1,#DATAE
		RET
PROOHM0:	MOV	DIGI_0,#00H
		MOV	DIGI_1,#00H
		MOV	DIGI_2,#00H
		MOV	A,#0AH
PROOHM1:	INC	DIGI_2
		CJNE	A,DIGI_2,PROOHM2
		MOV	DIGI_2,#0FFH
		INC	DIGI_1
		CJNE	A,DIGI_1,PROOHM1
		MOV	DIGI_1,#00H
		INC	DIGI_0
		CJNE	A,DIGI_0,PROOHM1
		JMP	CHANGOHM
PROOHM2:	DJNZ	RAMOHM,PROOHM1
;
CHANGOHM:	MOV	R0,#DP1
		MOV	A,DIGI_2
		CALL	COMPY
		MOV	R0,#DP2
		MOV	A,DIGI_1
		CALL	COMPY
		MOV	R0,#DP3
		MOV	A,DIGI_0
		CALL	COMPY
		ANL	DP2,#11011111B
		RET	
;***********************************************************
;		COMPY
;***********************************************************
COMPY:		CJNE	A,#01H,C1
		MOV	@R0,#DATA1
		MOV	BITPRO,#PASS
		RET
C1:		CJNE	A,#02H,C2
		MOV	@R0,#DATA2
		MOV	BITPRO,#PASS
		RET
C2:		CJNE	A,#03H,C3
		MOV	@R0,#DATA3
		MOV	BITPRO,#PASS
		RET
C3:		CJNE	A,#04H,C4
		MOV	@R0,#DATA4
		MOV	BITPRO,#PASS
		RET
C4:		CJNE	A,#05H,C5
		MOV	@R0,#DATA5
		MOV	BITPRO,#PASS
		RET
C5:		CJNE	A,#06H,C6
		MOV	@R0,#DATA6
		MOV	BITPRO,#PASS
		RET
C6:		CJNE	A,#07H,C7
		MOV	@R0,#DATA7
		MOV	BITPRO,#PASS
		RET
C7:		CJNE	A,#08H,C8
		MOV	@R0,#DATA8
		MOV	BITPRO,#PASS
		RET
C8:		CJNE	A,#09H,C9
		MOV	@R0,#DATA9
		MOV	BITPRO,#PASS
		RET
C9:		CJNE	A,#00H,C10
		MOV	@R0,#DATA0
		MOV	BITPRO,#PASS
C10:		RET
;
;******************************************************************************
;*			DELAY				    *
;******************************************************************************
;
DELAY:		MOV	R7,#08H
L0:		MOV	R6,#0F0H
		DJNZ	R6,$
		DJNZ	R7,L0
	RET	
DELAY1:		MOV	R5,#02H
DE1:		CALL	DELAY
		DJNZ	R5,DE1
	RET
DELAY2:		MOV	R5,#0AH
DE2:		CALL	DELAY
		DJNZ	R5,DE2
	RET
DELAYOHM:	MOV	R7,#01H
LOHM0:		MOV	R6,#0ffH
		DJNZ	R6,$
		DJNZ	R7,LOHM0
	RET	
;
;******************************************************************************
;*			ALARM				    *
;******************************************************************************
ALARM:		MOV	RAMALA,#80H
ALA1:		CPL	BUZZER
		CALL	DELAYOHM
		DJNZ	RAMALA,ALA1
		CLR	BUZZER
		RET		
;
END
